#include<stdio.h>
#include<stdlib.h>

#define N 58
#define thread_number 6

__device__ int DATA[N];
__device__ int schedule[N]; 


__host__ void make_data(int DATA[N], int schedule[N])
{
	        int i;
	        for(i = 0; i < N; i++)
	        {
	                DATA[i] = rand() % 10000 + 2;
			schedule[i] = i;
	        }
};

__host__ void reschedule(int DATA[N], int schedule[N])
{
	int i, j, n, min, tmp;
	int thread_sum[thread_number];
	for(i = 0; i < N; i++)
	{
		n = i;
		min = DATA[i];
		for(j = i + 1; j < N; j++)
		{
			if(min >= DATA[j])
			{
				min = DATA[j];
				n = j;
			}
		}
		tmp = DATA[n];
	        DATA[n] = DATA[i];
		DATA[i] = tmp;
		tmp = schedule[n];
		schedule[n] = schedule[i];
		schedule[i] = tmp;
	}
		
	int number = N/thread_number + 1;
	int a = N%thread_number;
	int b = (N-a)/thread_number;
	int count = a;
	int TMP[N];
	for(i = 0; i < a; i++)
	{
		TMP[i*number] = DATA[i];
		schedule[i] = i*number;
	}
	
	for(i = 0; i < b/2; i++)
	{
		for(j = 0;j < thread_number; j++)
		{
			if(j > a)
			{
				TMP[i*2+j*number-(j-a)] = DATA[count];
				TMP[i*2+j*number-(j-a)+1] = DATA[N-count+a-1];
				schedule[count] = i*2+j*number-(j-a);
				schedule[N-count+a-1] = i*2+j*number-(j-a)+1;
			}
			if( j == a)
			{
				TMP[i*2+j*number-(j-a)] = DATA[count];
				TMP[i*2+j*number-(j-a)+1] = DATA[N-count+a-1];
				schedule[count] = i*2+j*number-(j-a);
				schedule[N-count+a-1] = i*2+j*number-(j-a)+1;
			}
			else
			{
				TMP[i*2+1+j*number] = DATA[count];
				TMP[i*2+1+j*number+1] = DATA[N-count+a-1];
				schedule[count] = i*2+1+j*number;
				schedule[N-count+a-1] = i*2+1+j*number+1;
			}
			count++;
		}
	}
	if(b%2 != 0)
	{
		for(j = 0; j < thread_number; j++)
		{
			if(j%thread_number > a)
			{
				TMP[i*2+j*number-(j-a)] = DATA[count];
				schedule[count] = i*2+j*number-(j-a);
			}
			if(j%thread_number == a)
			{
				TMP[i*2+j*number-(j-a)] = DATA[count];
				schedule[count] = i*2+j*number-(j-a);
			}
			else
			{
				TMP[i*2+1+j*number] = DATA[count];
				schedule[count] = i*2+1+j*number;
			}
			count++;
		}
	}
	for(i=0;i<N;i++)
	{
		DATA[i] = TMP[i];
	}
}

__device__ void waste()
{
        int i,j,k;
        int WASTE[256];
        int n = 128;
        WASTE[0] = 0;
        for(i = 1; i < n;i++)
        {
	        for(j = 0; j < n; j++)
	        {
		        for(k = 0; k < n; k++)
		        {
			         WASTE[i] = i*j*k;
	                }
                }
        }
}

__global__ void loop(int *DATA, int *schedule)
{
        int i,j,a;
        a = 10 * threadIdx.x;
        if(threadIdx.x == 1)
        {
                a = 1;
        }
        for(j = 0; j < 10; j++)
        {
	        for(i = 0; i < DATA[a]; i++)
		{
			waste();
			printf("%c", schedule[a]+65);
		}
		a = a + 1;
	}
}


int main()
{
      int i;
      make_data(DATA, schedule);
      for(i = 0; i < N; i++)
      {
	      printf("%c:%d\n", i+65, DATA[i]);
      }
      reschedule(DATA,schedule);

      int *dev_a, *dev_b;
      cudaMalloc((void **)&dev_a, N*sizeof(int));
      cudaMalloc((void **)&dev_b, N*sizeof(int));
      cudaMemcpy(dev_a, &DATA, N*sizeof(int), cudaMemcpyHostToDevice);
      cudaMemcpy(dev_b, &schedule, N*sizeof(int), cudaMemcpyHostToDevice);
      loop<<<1,thread_number>>>(dev_a,dev_b);
      cudaMemcpy(&DATA, dev_a, N*sizeof(int), cudaMemcpyDeviceToHost);
      cudaMemcpy(&schedule, dev_b, N*sizeof(int), cudaMemcpyDeviceToHost);
      printf("\nend\n");
      cudaFree(dev_a);
      cudaFree(dev_b);
      return 0;
}
